#include <iostream>
#include <string>

using namespace std;

bool check(string l, int k) {
    int max = 0;
    int counter = 0;

    for (char i : l) {
        if (i == '(') {
            counter++;
            if (counter > max) max = counter;
        } else if(i == ')') counter--;
    }

    return max == k;
}

int get_l_value(string l, int n, int k) {
    if (l.size() == n) {
        if (check(l, k)) return 1;
        else return 0;
    }
    int sum = 0;

    sum += get_l_value('0' + l, n, k);
    if ('0' + l != l + '0') {
        sum += get_l_value(l + '0', n, k);
    }
    if (n - l.size() >= 2)
        sum += get_l_value('(' + l + ')', n, k);

    return sum;
}

int main() {
    int n, k;
    long ans;
    cin >> n >> k;

    cout << (get_l_value("0", n, k) + get_l_value("()", n, k));
}