n, m = map(int, input().split())
doors = {}

for y in range(1, n + 1):
    tmp = {}
    colors = input()
    for x in range(1, m):
        doors[(x, y)] = doors.get((x, y), [])
        doors[(x, y)].append([(x + 1, y), colors[x - 1]])
        if x + 1 <= m:
            doors[(x + 1, y)] = doors.get((x + 1, y), [])
            doors[(x + 1, y)].append([(x, y), colors[x - 1]])

import sys
sys.setrecursionlimit(10005)

class BFS:
    def __init__(self, x1, y1, x2, y2):
        self.visited = [(x1, y1)]
        self.res = self.visit(x1, y1, x2, y2)

    def visit(self, x, y, target_x, target_y, colors = ''):
        if x == target_x and y == target_y:
            return len(colors)

        counts = []

        for door in doors[(x, y)]:
            if door[0] not in self.visited:
                color = door[1]
                self.visited.append(door[0])
                if color not in colors:
                    colors += color

                counts.append(self.visit(*door[0], target_x, target_y, colors))

        return min(counts) if len(counts) else len(colors)

q = int(input())
for _ in range(q):
    y1, x1, y2, x2 = map(int, input().split())
    print(BFS(x1, y1, x2, y2).res)

